function x = vcircN(Dur,N)
% x = vcircN(Dur,N)
% fournit un signal complexe de longueur Dur
% prenant les N valeurs equiparties sur le cercle unite
% N vaut 8 par defaut
% P.Comon juillet 97
% voir aussi: discretR
% Exemple:
% L=300;ii=sqrt(-1);s=vcircN(L,8)+(randn(1,L)+ii*randn(1,L))/50;  
% figure(2);plot(real(s),imag(s),'.r');axis('square');title('v27')

if nargin==1,N=8;end;
ii=sqrt(-1);dpN=2*pi/N;
s=ceil(N*rand(1,Dur));

%x=cos(dpN*s)+ii*sin(dpN*s);
x=exp(ii*dpN*s);
